
Partial Class ContentFiles_Default
    Inherits System.Web.UI.Page

    ''' <summary>
    ''' Ta procedura obsugi zdarzenia preinicjalizacyjnego jest uruchamiana 
    ''' w celu przeprowadzenia inicjalizacji. 
    ''' Pozwala ona okreli motyw i tytu strony, ktre s wydobywane z pliku 
    ''' web.config za porednictwem udostpnionych waciwoci wspuytkowanej klasy Config.
    ''' </summary>
    Protected Sub Page_PreInit(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreInit
        Page.Theme = Config.CurrentTheme
        Page.Title = Config.PageTitle
    End Sub


    ''' <summary>
    ''' Przycisk Wylij dostarcza 3 procesw zapewniajcych
    ''' przechwytywanie pliku i danych. Sa one nastpujce: 
    ''' 
    ''' *	Wprowadzenie tekstowych informacji o pliku do bazy danych
    ''' *	Fizycznie pobranie pliku i umieszczenie go w przeznaczonym do tego celu folderze na serwerze
    ''' *	Wysanie odbiorcy wiadomoci e-mail z informacj na temat pliku gotowego do odebrania
    ''' 
    ''' </summary>
    Protected Sub btnSend_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSend.Click
        If FileUpload1.FileName <> "" Then
            'przelij plik na serwer...
            FileUpload1.SaveAs(Config.ShareLocalFolderPath _
                + FileUpload1.FileName)

            'zapisz informacje w bazie danych...
            Dim ResourceID As Integer = Resource.SaveResource( _
                FileUpload1.FileName, txtSenderEmail.Text, _
                txtRecipientEmail.Text, txtMessage.Text)
            'pobierz tre wiadomoci pocztowej...
            Dim emailBody As String = Resource.GetEmailBody( _
                txtMessage.Text, ResourceID, txtSenderEmail.Text, _
                txtRecipientEmail.Text)
            'wylij e-mail do odbiorcy...
            Utilities.SendEmail(txtRecipientEmail.Text, _
                txtSenderEmail.Text, Config.EmailSubject, emailBody)
            Server.Transfer("UploadComplete.aspx", True)
        End If
    End Sub

  
End Class
